class shoutcast::config (
  String $adminpassword = $::shoutcast::adminpassword,
  String $password = $::shoutcast::password,
  Hash $config = $::shoutcast::config
){
  $baseconfig = {
    'adminpassword'        => $adminpassword,
    'password'             => $password,
    'requirestreamconfigs' => '1',
    'pidfile'              => '/var/lib/shoutcast/sc_serv.pid',
    'banfile'              => '/var/lib/shoutcast/banfile',
    'ripfile'              => '/var/lib/shoutcast/ripfile'
  }

  $mainconfig = $baseconfig.merge($config)

  $mainconfigmapped = $mainconfig.map |$k,$v| {
    "$k=$v"
  }.join("\n")

  concat { '/etc/shoutcast.conf':
    ensure => present,
  }
  
  concat::fragment { 'mainconfig':
    target  => '/etc/shoutcast.conf',
    content => "$mainconfigmapped\n",
    order   => 0
  }

}
