class shoutcast::install (
  String $download_url = $::shoutcast::download_url
){

  file {'/var/lib/shoutcast':
    ensure => directory,
    owner  => 'shoutcast',
    group  => 'shoutcast',
    mode   => '0775'
  }

  file {'/opt/shoutcast':
    ensure => directory,
    owner  => 'root',
    group  => 'root',
    mode   => '0775'
  }

  user {'shoutcast':
    ensure   => present,
    comment  => 'Shoutcast User',
    home     => '/var/lib/shoutcast',
    shell    => '/bin/false',
  }

  archive {'/opt/shoutcast/shoutcast.tar.gz':
    ensure       => present,
    extract      => true,
    extract_path => '/opt/shoutcast',
    source       => $download_url,
    creates      => '/opt/shoutcast/sc_serv',
    cleanup      => true
  }

  file {'/etc/systemd/system/shoutcast.service':
    ensure  => file,
    owner   => 'root',
    group   => 'root',
    mode    => '0644',
    content => file('shoutcast/shoutcast.service'),
    notify  => Exec['refresh_systemd_shoutcast']
  }

  exec {'refresh_systemd_shoutcast':
    command     => '/bin/systemctl daemon-reload',
    refreshonly => true
  }
}
